<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>
        {{role.id == 0 ? 'Registrar novo perfil' : 'Atualizar perfil - '+role.name}}
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item">
            <a href="/roles" @click.prevent="$router.push({path:'/roles'})">Perfis</a>
          </li>
          <li class="breadcrumb-item active">{{role.id == 0 ? 'Registrar' : 'Atualizar'}}</li>
        </ol>
      </div>
    </div>
    <div class="card">
      <div :class="'card-body'">
        <!-- CADASTRO ROLE -->
        <form
          :class="(process.role ? ' whirl duo':'')"
          @submit.prevent="validateBeforeSubmitRole('role')"
          data-vv-scope="role"
        >
          <div class="card-body">
            <!-- NOME BANCO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Nome do perfil*</label>
              <div class="col-md-9">
                <input
                  v-model="role.name"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('role.name')}"
                  type="text"
                  name="role.name"
                >
                <span
                  v-show="errors.has('role.name')"
                  class="invalid-feedback"
                >Informe o nome do perfil</span>
              </div>
            </div>

            <span
              v-show="errors.has('role.permissions')"
              class="invalid-feedback"
            >Selecione as permissões</span>
            <fieldset>
              <div class="form-group row mb-2">
                <!-- <label class="col-md-3 col-form-label mb-2">Permissões</label> -->
                <div class="col-md-12">
                  <p class="mt-3">Selecione as permissões para este perfil</p>
                  <multiselect
                    v-model="role.permissions"
                    :options="permissions"
                    :multiple="true"
                    :close-on-select="false"
                    :clear-on-select="false"
                    :hide-selected="true"
                    :preserve-search="true"
                    placeholder="Insira aqui"
                    label="readable_name"
                    track-by="name"
                    tag-placeholder="Adicionar permissão"
                    :taggable="true"
                    @tag="addTag"
                  />
                  <span
                    style="color: red;font-size: 80%;"
                    v-show="selectError"
                  >Selecione as permissões</span>
                </div>
              </div>
              <div style="color:red">* Campos requeridos</div>
            </fieldset>
          </div>
          <div class="text-right">
            <b-button
              class="mr-1 mb-1"
              type="submit"
              :variant="'success'"
            >{{(role.id == 0 ? 'Registrar' : 'Atualizar')}}</b-button>
          </div>
        </form>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";
import Multiselect from "vue-multiselect";
import swal from "sweetalert2";

import Role from "@/domain/role/Role";
import Permission from "@/domain/permission/Permission";

import RoleService from "@/domain/role/RoleService";
import PermissionService from "@/domain/permission/PermissionService";

import NotificationProvider from "@/provider/NotificationProvider";

export default {
  name: "role-form",
  components: {
    Datatable,
    Multiselect
  },
  created() {
    if (this.$route.params.id) {
      this.process.role = true;
      this.roleService
        .get(this.$route.params.id)
        .then(role => {
          this.role = role;
          this.process.role = false;
        })
        .catch(err => {
          console.log(JSON.stringify(err));
          this.notificationProvider.error(
            "Falha na comunicação",
            "Falha ao listar os perfis"
          );
          this.process.role = false;
        });
    }
    // buscando permissions
    this.permissionService
      .list(999, 1)
      .then(response => {
        this.permissions = response;
      })
      .catch(err => {
        console.log(JSON.stringify(err));
        this.notificationProvider.error(
          "Falha na comunicação",
          "Falha ao listar as permissões"
        );
      });
  },
  data() {
    return {
      selectError: false,
      process: {
        role: false
      },
      roleService: new RoleService(),
      permissionService: new PermissionService(),
      roles: [],
      role: new Role(),
      permissions: [],
      permission: new Permission(),
      notificationProvider: new NotificationProvider(this.$notify),
      dtOptions: {
        paging: true, // Table pagination
        ordering: true, // Column ordering
        info: true, // Bottom left status text
        responsive: true,
        // Text translation options
        // Note the required keywords between underscores (e.g _MENU_)
        oLanguage: {
          sSearch: '<em class="fa fa-search"></em>',
          sLengthMenu: "_MENU_ registros por página",
          info: "Página _PAGE_ de _PAGES_",
          zeroRecords: "Nada encontrado",
          infoEmpty: "Nenhum registro",
          infoFiltered: "(Filtrado de _MAX_ itens)",
          oPaginate: {
            sNext: '<em class="fa fa-caret-right"></em>',
            sPrevious: '<em class="fa fa-caret-left"></em>'
          }
        },
        // Datatable key setup
        keys: false
      }
    };
  },
  methods: {
    // ROLES
    validateBeforeSubmitRole(scope) {
      this.$validator.validateAll(scope).then(result => {
        if (this.role.permissions.length == 0) {
          this.selectError = true;
          return;
        } else {
          this.selectError = false;
        }
        if (result) {
          this.process.role = true;
          if (this.role.id == 0) {
            // CADASTRANDO
            this.roleService
              .create(this.role)
              .then(response => {
                this.roles.push(response);
                this.role = new Role();
                this.process.role = false;
                this.notificationProvider.success(
                  "REGISTRADO!",
                  this.role.name + " registrada com sucesso"
                );
                this.$router.push({ path: "/roles" });
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response &&
                  err.response.data &&
                  err.response.data.exception &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  // alguma validação deu errado
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao registrar o perfil"
                  );
                }
                this.process.role = false;
              });
          } else {
            // EDITANDO
            this.roleService
              .update(this.role.id, this.role)
              .then(response => {
                for (var i = 0; i < this.roles.length; i++) {
                  if (this.roles[i].id == response.id) {
                    this.roles[i] = new Role(
                      response.id,
                      response.name,
                      response.permissions
                    );
                  }
                }
                this.notificationProvider.success(
                  "ATUALIZADO!",
                  this.role.name + " atualizada com sucesso"
                );
                this.$router.push({ path: "/roles" });
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response &&
                  err.response.data &&
                  err.response.data.exception &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  // alguma validação deu errado
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao atualizar o perfil"
                  );
                }
                this.process.role = false;
              });
          }
        }
      });
    },
    addRole() {
      this.role = new Role();
    },
    addTag(newTag) {
      this.role.permissions.push({
        name: newTag,
        language: "Some language"
      });
    }
  }
};
</script>
<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>